import java.util.Scanner;
PFont Univers;
PImage imgBase1, imgBase2, marker;
String[] data00,data02,data04,data06,data08;
String[][] dataArr;
Industry[][] yearArr;
int yearIndex;
int curState;
int curYear;
int maxCircWidth;
color cYellow, cGreen, cOrange, cRorange, cMagenta, cTeal, cBlue, cRed, cPurple;
color[] colArr;
float[] xPos, yPos, radius, targetX,targetY,targetRadius;
float targetMarkerX, markerX;
double timer;
boolean bDisplay;

float[][] avgHappinessArr;
String[] indTitleArr;
int[][] avgSalariesArr;
int[] avgMinSal, avgMaxSal;
float[] avgMinHap,avgMaxHap;
boolean bDragMarker;

void setup(){
  size(950,650);
  background(73,73,70);
  Univers=createFont("UniversLT-Condensed",12,true);
  textFont(Univers);
  smooth();
  imgBase1=loadImage("imgBase.jpg");
  imgBase2=loadImage("imgBase2.jpg");
  marker=loadImage("marker.jpg");
  data00 = loadStrings("final_00.txt");
  data02 = loadStrings("final_02.txt");
  data04 = loadStrings("final_04.txt");
  data06 = loadStrings("final_06.txt");
  data08 = loadStrings("final_08.txt");
  dataArr = new String[5][];
  dataArr[0] = data00;
  dataArr[1] = data02;
  dataArr[2] = data04;
  dataArr[3] = data06;
  dataArr[4] = data08;
  yearArr=new Industry[5][9];
  curState=10;
  curYear=0;
  cYellow=color(255,253,94);
  cGreen=color(60,184,120);
  cOrange=color(245,184,37);
  cRorange=color(252,126,71);
  cMagenta=color(222,73,161);
  cTeal=color(36,172,165);
  cBlue=color(93,195,213);
  cRed=color(227,104,109);
  cPurple=color(175,45,172);
  colArr=new color[9];
  colArr[0]=cYellow;
  colArr[1]=cGreen;
  colArr[2]=cOrange;
  colArr[3]=cRorange;
  colArr[4]=cMagenta;
  colArr[5]=cTeal;
  colArr[6]=cBlue;
  colArr[7]=cRed;
  colArr[8]=cPurple;
  indTitleArr=new String[9];
  indTitleArr[0]="TECHNOLOGY";
  indTitleArr[1]="MEDICAL";
  indTitleArr[2]="GOVERNMENT";
  indTitleArr[3]="EDUCATION";
  indTitleArr[4]="BUSINESS";
  indTitleArr[5]="SERVICE";
  indTitleArr[6]="CONSTRUCTION";
  indTitleArr[7]="OFFICE";
  indTitleArr[8]="TRANSPORTATION";
  avgSalariesArr=new int[5][9];
  avgHappinessArr=new float[5][9];
  avgMinSal =new int[5];
  avgMaxSal =new int[5];
  avgMinHap =new float[5];
  avgMaxHap =new float[5];
  targetX = new float[30];
  targetY = new float[30];
  targetRadius = new float[30];
  xPos = new float[30];
  yPos = new float[30];
  targetMarkerX=625;
  markerX=625;
  radius = new float[30];
  timer = millis();
  loadData();
  bDragMarker=false;
  bDisplay=false;
}

void draw(){
  background(0);
  image(imgBase1,0,0);
  fill(255);
  text("Categories",730,30);
  fill(110,190,180);
  text("Top 25 Jobs",730,45);
  fill(255);
  text("Alphabetical",863,30);
  text("Happiness",863,45);
  text("Salary",863,60);
  drawCircles();
  drawMarker();
  image(imgBase2,0,611);
  //println(mouseX+" " +mouseY);
}

void drawMarker(){
  markerX+=(targetMarkerX-markerX)/10;
  image(marker,markerX,112);
  stroke(255);
  if(mousePressed&&isHovering(markerX+5,118,25)){
    bDragMarker=true;
  }
  if(bDragMarker){
    if(mouseX>markerX+56 && mouseX<906 && (millis()-timer>250)){
      timer=millis();
      targetMarkerX+=70;
      curYear=curYear+1;
    }
    if(mouseX<markerX-56 && mouseX>624 && (millis()-timer>250)){
      timer=millis();
      targetMarkerX-=70;
      curYear=curYear-1;
    }
  }
  if(curYear==1){
    fill(250);
    text("2002", 689,108);
  }else if(curYear==2){
    fill(250);
    text("2004", 758,108);
  } else if(curYear==3){
    fill(250);
    text("2006", 828,108);
  }
}

void drawCircles(){
  if(curState==10){
    maxCircWidth=870/9;
    for(int i=0;i<9;i++){
      //println(avgMinSal[curYear] + " " + avgMaxSal[curYear] + " " + avgMinHap[curYear] + " " + avgMaxHap[curYear]);
      targetRadius[i]=(int)map(avgSalariesArr[curYear][i],0,avgMaxSal[curYear],20,maxCircWidth*2);
      targetY[i]=(int)map(avgHappinessArr[curYear][i],0,1.25,0,490-maxCircWidth);
      targetX[i]=(i+.5)*maxCircWidth+50;
      xPos[i]+=(targetX[i]-xPos[i])/8;
      yPos[i]+=(targetY[i]-yPos[i])/8;
      radius[i]+=(targetRadius[i]-radius[i])/8;
      fill(colArr[i]);
      noStroke();
      ellipse(xPos[i],(height-55)-yPos[i],radius[i],radius[i]);
      if (isHovering(xPos[i],(height-55)-yPos[i],radius[i])){
        fill(110,210,200);
        rect(mouseX-2,mouseY-12,textWidth(indTitleArr[i])+10,-(textAscent()+textDescent()+5));
        triangle(mouseX-2,mouseY-12,mouseX+8,mouseY-12,mouseX-2,mouseY-2);
        fill(255);
        text(indTitleArr[i],mouseX+2,mouseY-17);
        text(indTitleArr[i],915-textWidth(indTitleArr[i]),150);
        text("$" + avgSalariesArr[curYear][i],915-textWidth("$" + Integer.toString(avgSalariesArr[curYear][i])),165);
        if(mousePressed&&(millis()-timer>500)){
          timer=millis();
          curState=i;
        }
      }
    }
    for(int i=9;i<30;i++){
      yPos[i]=-500;
    }
  }
  else{
    int jobs=yearArr[curYear][curState].numOccupations;
    maxCircWidth=870/jobs;
    for(int i=0;i<jobs;i++){
      targetRadius[i]=(int)map(yearArr[curYear][curState].salariesArr[i],yearArr[curYear][curState].minSal,yearArr[curYear][curState].maxSal,20,maxCircWidth*1.5);
      targetY[i]=(int)map(yearArr[curYear][curState].happinessArr[i],0,3,0,490-maxCircWidth);
      targetX[i]=(i+.5)*maxCircWidth+50;
      xPos[i]+=(targetX[i]-xPos[i])/8;
      yPos[i]+=(targetY[i]-yPos[i])/8;
      radius[i]+=(targetRadius[i]-radius[i])/8;
      fill(colArr[curState]);
      noStroke();
      ellipse(xPos[i],(height-55)-yPos[i],radius[i],radius[i]);
      if (isHovering(xPos[i],(height-55)-yPos[i],radius[i])){
        fill(110,210,200);
        rect(mouseX-2,mouseY-12,textWidth(yearArr[curYear][curState].occTitleArr[i].toUpperCase())+10,-(textAscent()+textDescent()+5));
        triangle(mouseX-2,mouseY-12,mouseX+8,mouseY-12,mouseX-2,mouseY-2);
        fill(255);
        text(yearArr[curYear][curState].occTitleArr[i].toUpperCase(),mouseX+2,mouseY-17);
        text(yearArr[curYear][curState].occTitleArr[i].toUpperCase(),915-textWidth(yearArr[curYear][curState].occTitleArr[i].toUpperCase()),150);
        text("$" + yearArr[curYear][curState].salariesArr[i],915-textWidth("$" + Integer.toString(yearArr[curYear][curState].salariesArr[i])),165);
        if(mousePressed&&(millis()-timer>500)){
          timer=millis();
          curState=10;
          break;
        }
      }
    }
    for(int i=jobs;i<30;i++){
      yPos[i]=-500;
    }
  }
}

void loadData(){
  for(int i=0;i<dataArr.length;i++){
    yearArr[yearIndex] = new Industry[9];
    Scanner s = new Scanner(dataArr[i][0]).useDelimiter("\t");
    for(int j=0;j<9;j++){
      yearArr[yearIndex][j] = new Industry(s.nextInt());
    }
    s.close();
    int lastInd=-1;
    int indIndex=-1;
    for (int j=1; j<dataArr[i].length;j++){
      int Ind=Integer.parseInt(dataArr[i][j].substring(0,1));
      if(lastInd!=Ind){
        indIndex++;
      }
      yearArr[yearIndex][indIndex].initOcc(dataArr[i][j].substring(2));
      yearArr[yearIndex][indIndex].getMaxMins();
      lastInd=Ind;
    }
    yearIndex++;
  }
  //////CALCULATE INDUSTRY AVERAGES
  for(int i=0;i<yearArr.length;i++){
    avgMinSal[i]=yearArr[i][0].salariesArr[0];
    avgMaxSal[i]=yearArr[i][0].salariesArr[0];
    avgMinHap[i]=yearArr[i][0].happinessArr[0];
    avgMaxHap[i]=yearArr[i][0].happinessArr[0];
    for(int j=0;j<yearArr[i].length;j++){      // j is Industry
      int salSum=0;
      float hapSum=0;
      int numEmpSum=0;
      for(int k=0;k<yearArr[i][j].numOccupations;k++){
        salSum+=yearArr[i][j].salariesArr[k]*yearArr[i][j].numEmpArr[k];
        numEmpSum+=yearArr[i][j].numEmpArr[k];        
      }
      for(int k=0;k<yearArr[i][j].happinessArr.length;k++){
        hapSum+=yearArr[i][j].happinessArr[k]*yearArr[i][j].numEmpArr[k];
        numEmpSum+=yearArr[i][j].numEmpArr[k];  
      }
      avgHappinessArr[i][j]=hapSum/numEmpSum;
      avgSalariesArr[i][j]=salSum/numEmpSum;
      if (avgMinSal[i]>avgSalariesArr[i][j]){
        avgMinSal[i]=avgSalariesArr[i][j];
      }
      if (avgMaxSal[i]<avgSalariesArr[i][j]){
        avgMaxSal[i]=avgSalariesArr[i][j];
      }
      if (avgMinHap[i]>avgHappinessArr[i][j]){
        avgMinHap[i]=avgHappinessArr[i][j];
      }
      if (avgMaxHap[i]<avgHappinessArr[i][j]){
        avgMaxHap[i]=avgHappinessArr[i][j];
      }
    }
  }
  maxCircWidth=870/9;
  for(int i=0;i<9;i++){
    xPos[i]=(i+.5)*maxCircWidth+50;
    yPos[i]=-500;
  }
}

boolean isHovering(float x, float y, float radius){
  float xNum = pow( (mouseX- (x) ) ,2);
  float yNum = pow( (mouseY- (y) ) ,2);
  float rNum = pow(radius/2,2);
  boolean bAns= ((xNum+yNum) < (rNum));
  return bAns;
}

void mouseReleased(){
  bDragMarker=false;
}

void keyPressed(){
  if (keyCode==RIGHT){
    if (curYear<4){
      targetMarkerX+=70;
      curYear=curYear+1;
    }
  }
  if (keyCode==LEFT){
    if (curYear>0){
      targetMarkerX-=70;
      curYear=curYear-1;
    }
  }
}
